"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_to_regexp_1 = __importDefault(require("path-to-regexp"));
const hasTrailingSlash = (path) => path.length > 1 && path.slice(-1) === '/';
const sansTrailingSlash = (path) => hasTrailingSlash(path) ? path.slice(0, -1) : path;
const pickPath = (path, routes, parentPattern = '') => {
    const patterns = Object.keys(routes);
    for (const pattern of patterns) {
        const value = routes[pattern];
        const fullPattern = parentPattern + sansTrailingSlash(pattern);
        if (hasTrailingSlash(pattern)) {
            const possibleMatch = pickPath(path, value, fullPattern);
            if (possibleMatch.pattern !== null) {
                return possibleMatch;
            }
        }
        const re = path_to_regexp_1.default(pattern === '/' ? parentPattern : fullPattern);
        const params = re.exec(path);
        if (params !== null) {
            return {
                pattern: fullPattern,
                value: value,
                params: params.slice(1)
            };
        }
    }
    return {
        pattern: null,
        value: null,
        params: []
    };
};
exports.default = pickPath;
//# sourceMappingURL=index.js.map